Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 75772)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -2205,206 +2542,57 @@
     NTSTATUS Status;
     superblock* sb;
     int i = 0;
-    
+
     sb = ExAllocatePoolWithTag(PagedPool, sizeof(superblock), ALLOC_TAG);
     if (!sb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlZeroMemory(sb, sizeof(superblock));
-    
-    while (superblock_addrs[i] > 0 && dev->length >= superblock_addrs[i] + sizeof(superblock)) {
+
+    while (superblock_addrs[i] > 0 && dev->devitem.num_bytes >= superblock_addrs[i] + sizeof(superblock)) {
         Status = write_data_phys(dev->devobj, superblock_addrs[i], sb, sizeof(superblock));
-        
+
         if (!NT_SUCCESS(Status)) {
             ExFreePool(sb);
             return Status;
         }
-        
+
         i++;
     }
-    
+
     ExFreePool(sb);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS replace_mount_dev(device_extension* Vcb, device* dev, PDEVICE_OBJECT mountmgr, BOOL part0) {
+static NTSTATUS finish_removing_device(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, device* dev) {
+    KEY searchkey;
+    traverse_ptr tp;
     NTSTATUS Status;
-    MOUNTDEV_NAME mdn, *mdn2 = NULL, *mdn3 = NULL;
-    ULONG mdnsize, mmpsize;
-    MOUNTMGR_MOUNT_POINT* mmp = NULL;
-    MOUNTMGR_MOUNT_POINTS mmps, *mmps2 = NULL;
-    ULONG i;
-    UNICODE_STRING us;
+    LIST_ENTRY* le;
+    volume_device_extension* vde;
 
-    // get old device name
-    
-    Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        return Status;
-    }
-    
-    mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
-    
-    mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
-    if (!mdn2) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        goto end;
-    }
-    
-    // get new device name
-    
-    Status = dev_ioctl(first_device(Vcb)->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        goto end2;
-    }
-    
-    mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
-    
-    mdn3 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
-    if (!mdn3) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end2;
-    }
-    
-    Status = dev_ioctl(first_device(Vcb)->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn3, mdnsize, TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-        goto end2;
-    }
-    
-    // query and delete existing mount points
-    
-    mmpsize = sizeof(MOUNTMGR_MOUNT_POINT) + mdn2->NameLength;
-    
-    mmp = ExAllocatePoolWithTag(PagedPool, mmpsize, ALLOC_TAG);
-    if (!mmp) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end2;
-    }
-    
-    RtlZeroMemory(mmp, sizeof(MOUNTMGR_MOUNT_POINT));
-    mmp->DeviceNameOffset = sizeof(MOUNTMGR_MOUNT_POINT);
-    mmp->DeviceNameLength = mdn2->NameLength;
-    RtlCopyMemory(&mmp[1], mdn2->Name, mdn2->NameLength);
-    
-    Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_QUERY_POINTS, mmp, mmpsize, &mmps, mmpsize, TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTMGR_QUERY_POINTS returned %08x\n", Status);
-        goto end2;
-    }
-    
-    mmps2 = ExAllocatePoolWithTag(PagedPool, mmps.Size, ALLOC_TAG);
-    if (!mmps2) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end2;
-    }
-    
-    Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_DELETE_POINTS, mmp, mmpsize, mmps2, mmps.Size, TRUE, NULL);
-    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("IOCTL_MOUNTMGR_DELETE_POINTS returned %08x\n", Status);
-        goto end2;
-    }
-    
-    // re-create mount points
-    
-    for (i = 0; i < mmps2->NumberOfMountPoints; i++) {
-        if (mmps2->MountPoints[i].SymbolicLinkNameOffset != 0) {
-            ULONG mcpilen;
-            MOUNTMGR_CREATE_POINT_INPUT* mcpi;
-            
-            mcpilen = sizeof(MOUNTMGR_CREATE_POINT_INPUT) + mmps2->MountPoints[i].SymbolicLinkNameLength + mdn3->NameLength;
-            
-            mcpi = ExAllocatePoolWithTag(PagedPool, mcpilen, ALLOC_TAG);
-            if (!mcpi) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end2;
-            }
-            
-            mcpi->SymbolicLinkNameOffset = sizeof(MOUNTMGR_CREATE_POINT_INPUT);
-            mcpi->SymbolicLinkNameLength = mmps2->MountPoints[i].SymbolicLinkNameLength;
-            mcpi->DeviceNameOffset = mcpi->SymbolicLinkNameOffset + mcpi->SymbolicLinkNameLength;
-            mcpi->DeviceNameLength = mdn3->NameLength;
-            
-            RtlCopyMemory((UINT8*)mcpi + mcpi->SymbolicLinkNameOffset, (UINT8*)mmps2 + mmps2->MountPoints[i].SymbolicLinkNameOffset,
-                          mcpi->SymbolicLinkNameLength);
-            RtlCopyMemory((UINT8*)mcpi + mcpi->DeviceNameOffset, mdn3->Name, mdn3->NameLength);
+    if (Vcb->need_write) {
+        Status = do_write(Vcb, NULL);
 
-            Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_CREATE_POINT, mcpi, mcpilen, NULL, 0, TRUE, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("IOCTL_MOUNTMGR_CREATE_POINT returned %08x\n", Status);
-                ExFreePool(mcpi);
-                goto end2;
-            }
-            
-            ExFreePool(mcpi);
-        }
-    }
-    
-    Status = STATUS_SUCCESS;
-    
-end2:
-    // re-add old device back to mountmgr
-    
-    if (!part0) {
-        us.Buffer = mdn2->Name;
-        us.Length = us.MaximumLength = mdn2->NameLength;
-        
-        add_volume(mountmgr, &us);
-    }
-    
-end:
-    if (mdn2)
-        ExFreePool(mdn2);
-    
-    if (mdn3)
-        ExFreePool(mdn3);
-    
-    if (mmp)
-        ExFreePool(mmp);
-    
-    if (mmps2)
-        ExFreePool(mmps2);
+        if (!NT_SUCCESS(Status))
+            ERR("do_write returned %08x\n", Status);
+    } else
+        Status = STATUS_SUCCESS;
 
-    return Status;
-}
+    free_trees(Vcb);
 
-static NTSTATUS finish_removing_device(device_extension* Vcb, device* dev) {
-    KEY searchkey;
-    traverse_ptr tp;
-    NTSTATUS Status;
-    LIST_ENTRY rollback, *le;
-    BOOL first_dev, part0 = FALSE;
-    
-    InitializeListHead(&rollback);
-    
-    if (Vcb->need_write)
-        do_write(Vcb, NULL, &rollback);
-    
-    free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
+    if (!NT_SUCCESS(Status))
+        return Status;
+
     // remove entry in chunk tree
 
     searchkey.obj_id = 1;
     searchkey.obj_type = TYPE_DEV_ITEM;
     searchkey.offset = dev->devitem.dev_id;
-    
+
     Status = find_item(Vcb, Vcb->chunk_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
@@ -2411,15 +2599,21 @@
         return Status;
     }
 
-    if (!keycmp(searchkey, tp.item->key))
-        delete_tree_item(Vcb, &tp, &rollback);
-    
+    if (!keycmp(searchkey, tp.item->key)) {
+        Status = delete_tree_item(Vcb, &tp);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
+
     // remove stats entry in device tree
-    
+
     searchkey.obj_id = 0;
     searchkey.obj_type = TYPE_DEV_STATS;
     searchkey.offset = dev->devitem.dev_id;
-    
+
     Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
@@ -2426,146 +2620,447 @@
         return Status;
     }
 
-    if (!keycmp(searchkey, tp.item->key))
-        delete_tree_item(Vcb, &tp, &rollback);
-    
+    if (!keycmp(searchkey, tp.item->key)) {
+        Status = delete_tree_item(Vcb, &tp);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
+
     // update superblock
-    
+
     Vcb->superblock.num_devices--;
     Vcb->superblock.total_bytes -= dev->devitem.num_bytes;
     Vcb->devices_loaded--;
-    
-    first_dev = first_device(Vcb) == dev;
-    
+
     RemoveEntryList(&dev->list_entry);
-    
+
     // flush
-    
-    do_write(Vcb, NULL, &rollback);
-    
+
+    Status = do_write(Vcb, NULL);
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
+
     free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
-    if (!dev->readonly) {
+
+    if (!NT_SUCCESS(Status))
+        return Status;
+
+    if (!dev->readonly && dev->devobj) {
         Status = remove_superblocks(dev);
         if (!NT_SUCCESS(Status))
             WARN("remove_superblocks returned %08x\n", Status);
     }
-    
+
     // remove entry in volume list
-    
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    
-    le = volumes.Flink;
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        
-        if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) &&
-            RtlCompareMemory(&dev->devitem.device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-            PFILE_OBJECT FileObject;
-            PDEVICE_OBJECT mountmgr;
-            UNICODE_STRING mmdevpath;
-        
-            RemoveEntryList(&v->list_entry);
-        
-            // re-add entry to mountmgr
 
-            if (!first_dev && v->part_num != 0) {
-                RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
-                Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
-                if (!NT_SUCCESS(Status))
-                    ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
-                else {
-                    add_volume(mountmgr, &v->devpath);
-                    ObDereferenceObject(FileObject);
+    vde = Vcb->vde;
+
+    if (dev->devobj) {
+        pdo_device_extension* pdode = vde->pdode;
+
+        ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+
+        le = pdode->children.Flink;
+        while (le != &pdode->children) {
+            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+
+            if (RtlCompareMemory(&dev->devitem.device_uuid, &vc->uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
+                PFILE_OBJECT FileObject;
+                PDEVICE_OBJECT mountmgr;
+                UNICODE_STRING mmdevpath;
+
+                pdode->children_loaded--;
+
+                if (vc->had_drive_letter) { // re-add entry to mountmgr
+                    RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+                    Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
+                    if (!NT_SUCCESS(Status))
+                        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+                    else {
+                        MOUNTDEV_NAME mdn;
+
+                        Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+                        if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
+                            ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                        else {
+                            MOUNTDEV_NAME* mdn2;
+                            ULONG mdnsize = (ULONG)offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+
+                            mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
+                            if (!mdn2)
+                                ERR("out of memory\n");
+                            else {
+                                Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+                                if (!NT_SUCCESS(Status))
+                                    ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                                else {
+                                    UNICODE_STRING name;
+
+                                    name.Buffer = mdn2->Name;
+                                    name.Length = name.MaximumLength = mdn2->NameLength;
+
+                                    Status = mountmgr_add_drive_letter(mountmgr, &name);
+                                    if (!NT_SUCCESS(Status))
+                                        WARN("mountmgr_add_drive_letter returned %08x\n", Status);
+                                }
+
+                                ExFreePool(mdn2);
+                            }
+                        }
+
+                        ObDereferenceObject(FileObject);
+                    }
                 }
+
+                ExFreePool(vc->pnp_name.Buffer);
+                RemoveEntryList(&vc->list_entry);
+                ExFreePool(vc);
+
+                ObDereferenceObject(vc->fileobj);
+
+                break;
             }
-            
-            part0 = v->part_num == 0 ? TRUE : FALSE;
-        
-            if (v->devpath.Buffer)
-                ExFreePool(v->devpath.Buffer);
-            
-            ExFreePool(v);
-            break;
+
+            le = le->Flink;
         }
-        
-        le = le->Flink;
-    }
-    
-    ExReleaseResourceLite(&volumes_lock);
-    
-    if (first_dev) {
-        PDEVICE_OBJECT DeviceObject, olddev;
-        device* newfirstdev;
-        PFILE_OBJECT FileObject;
-        UNICODE_STRING mmdevpath;
-        PDEVICE_OBJECT mountmgr;
-        
-        DeviceObject = Vcb->Vpb->DeviceObject;
-        
-        olddev = DeviceObject->Vpb->RealDevice;
-        newfirstdev = first_device(Vcb);
-        
-        ObReferenceObject(newfirstdev->devobj);
-        DeviceObject->Vpb->RealDevice = newfirstdev->devobj;
-        ObDereferenceObject(olddev);
-        
-        RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
-        Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
-        if (!NT_SUCCESS(Status))
-            ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
-        else {
-            Status = replace_mount_dev(Vcb, dev, mountmgr, part0);
-            if (!NT_SUCCESS(Status))
-                ERR("replace_mount_dev returned %08x\n", Status);
-            
-            ObDereferenceObject(FileObject);
+
+        if (pdode->children_loaded > 0 && vde->device->Characteristics & FILE_REMOVABLE_MEDIA) {
+            vde->device->Characteristics &= ~FILE_REMOVABLE_MEDIA;
+
+            le = pdode->children.Flink;
+            while (le != &pdode->children) {
+                volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+
+                if (vc->devobj->Characteristics & FILE_REMOVABLE_MEDIA) {
+                    vde->device->Characteristics |= FILE_REMOVABLE_MEDIA;
+                    break;
+                }
+
+                le = le->Flink;
+            }
         }
-        
+
+        pdode->num_children = Vcb->superblock.num_devices;
+
+        ExReleaseResourceLite(&pdode->child_lock);
+
+        // free dev
+
+        if (dev->trim && !dev->readonly && !Vcb->options.no_trim)
+            trim_whole_device(dev);
     }
-    
-    // free dev
-    
-    ObDereferenceObject(dev->devobj);
-    
+
     while (!IsListEmpty(&dev->space)) {
         LIST_ENTRY* le2 = RemoveHeadList(&dev->space);
         space* s = CONTAINING_RECORD(le2, space, list_entry);
-        
+
         ExFreePool(s);
     }
-    
+
     ExFreePool(dev);
-    
+
+    if (Vcb->trim) {
+        Vcb->trim = FALSE;
+
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+
+            if (dev2->trim) {
+                Vcb->trim = TRUE;
+                break;
+            }
+
+            le = le->Flink;
+        }
+    }
+
+    FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+
     return STATUS_SUCCESS;
 }
 
+static void trim_unalloc_space(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, device* dev) {
+    DEVICE_MANAGE_DATA_SET_ATTRIBUTES* dmdsa;
+    DEVICE_DATA_SET_RANGE* ranges;
+    ULONG datalen, i;
+    KEY searchkey;
+    traverse_ptr tp;
+    NTSTATUS Status;
+    BOOL b;
+    UINT64 lastoff = 0x100000; // don't TRIM the first megabyte, in case someone has been daft enough to install GRUB there
+    LIST_ENTRY* le;
+
+    dev->num_trim_entries = 0;
+
+    searchkey.obj_id = dev->devitem.dev_id;
+    searchkey.obj_type = TYPE_DEV_EXTENT;
+    searchkey.offset = 0;
+
+    Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        return;
+    }
+
+    do {
+        traverse_ptr next_tp;
+
+        if (tp.item->key.obj_id == dev->devitem.dev_id && tp.item->key.obj_type == TYPE_DEV_EXTENT) {
+            if (tp.item->size >= sizeof(DEV_EXTENT)) {
+                DEV_EXTENT* de = (DEV_EXTENT*)tp.item->data;
+
+                if (tp.item->key.offset > lastoff)
+                    add_trim_entry_avoid_sb(Vcb, dev, lastoff, tp.item->key.offset - lastoff);
+
+                lastoff = tp.item->key.offset + de->length;
+            } else {
+                ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DEV_EXTENT));
+                return;
+            }
+        }
+
+        b = find_next_item(Vcb, &tp, &next_tp, FALSE, NULL);
+
+        if (b) {
+            tp = next_tp;
+            if (tp.item->key.obj_id > searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type > searchkey.obj_type))
+                break;
+        }
+    } while (b);
+
+    if (lastoff < dev->devitem.num_bytes)
+        add_trim_entry_avoid_sb(Vcb, dev, lastoff, dev->devitem.num_bytes - lastoff);
+
+    if (dev->num_trim_entries == 0)
+        return;
+
+    datalen = (ULONG)sector_align(sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), sizeof(UINT64)) + (dev->num_trim_entries * sizeof(DEVICE_DATA_SET_RANGE));
+
+    dmdsa = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
+    if (!dmdsa) {
+        ERR("out of memory\n");
+        goto end;
+    }
+
+    dmdsa->Size = sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES);
+    dmdsa->Action = DeviceDsmAction_Trim;
+    dmdsa->Flags = DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED;
+    dmdsa->ParameterBlockOffset = 0;
+    dmdsa->ParameterBlockLength = 0;
+    dmdsa->DataSetRangesOffset = (ULONG)sector_align(sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), sizeof(UINT64));
+    dmdsa->DataSetRangesLength = dev->num_trim_entries * sizeof(DEVICE_DATA_SET_RANGE);
+
+    ranges = (DEVICE_DATA_SET_RANGE*)((UINT8*)dmdsa + dmdsa->DataSetRangesOffset);
+
+    i = 0;
+    le = dev->trim_list.Flink;
+    while (le != &dev->trim_list) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+
+        ranges[i].StartingOffset = s->address;
+        ranges[i].LengthInBytes = s->size;
+        i++;
+
+        le = le->Flink;
+    }
+
+    Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES, dmdsa, datalen, NULL, 0, TRUE, NULL);
+    if (!NT_SUCCESS(Status))
+        WARN("IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES returned %08x\n", Status);
+
+    ExFreePool(dmdsa);
+
+end:
+    while (!IsListEmpty(&dev->trim_list)) {
+        space* s = CONTAINING_RECORD(RemoveHeadList(&dev->trim_list), space, list_entry);
+        ExFreePool(s);
+    }
+
+    dev->num_trim_entries = 0;
+}
+
+static NTSTATUS try_consolidation(device_extension* Vcb, UINT64 flags, chunk** newchunk) {
+    NTSTATUS Status;
+    BOOL changed;
+    LIST_ENTRY* le;
+    chunk* rc;
+
+    // FIXME - allow with metadata chunks?
+
+    while (TRUE) {
+        rc = NULL;
+
+        ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+        ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
+
+        // choose the least-used chunk we haven't looked at yet
+        le = Vcb->chunks.Flink;
+        while (le != &Vcb->chunks) {
+            chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+
+            // FIXME - skip full-size chunks over e.g. 90% full?
+            if (c->chunk_item->type & BLOCK_FLAG_DATA && !c->readonly && c->balance_num != Vcb->balance.balance_num && (!rc || c->used < rc->used))
+                rc = c;
+
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&Vcb->chunk_lock);
+
+        if (!rc) {
+            ExReleaseResourceLite(&Vcb->tree_lock);
+            break;
+        }
+
+        if (rc->list_entry_balance.Flink) {
+            RemoveEntryList(&rc->list_entry_balance);
+            Vcb->balance.chunks_left--;
+        }
+
+        rc->list_entry_balance.Flink = (LIST_ENTRY*)1; // so it doesn't get dropped
+        rc->reloc = TRUE;
+
+        ExReleaseResourceLite(&Vcb->tree_lock);
+
+        do {
+            changed = FALSE;
+
+            Status = balance_data_chunk(Vcb, rc, &changed);
+            if (!NT_SUCCESS(Status)) {
+                ERR("balance_data_chunk returned %08x\n", Status);
+                Vcb->balance.status = Status;
+                rc->list_entry_balance.Flink = NULL;
+                rc->reloc = FALSE;
+                return Status;
+            }
+
+            KeWaitForSingleObject(&Vcb->balance.event, Executive, KernelMode, FALSE, NULL);
+
+            if (Vcb->readonly)
+                Vcb->balance.stopping = TRUE;
+
+            if (Vcb->balance.stopping)
+                return STATUS_SUCCESS;
+        } while (changed);
+
+        rc->list_entry_balance.Flink = NULL;
+
+        rc->changed = TRUE;
+        rc->space_changed = TRUE;
+        rc->balance_num = Vcb->balance.balance_num;
+
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status)) {
+            ERR("do_write returned %08x\n", Status);
+            return Status;
+        }
+    }
+
+    ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+    Status = alloc_chunk(Vcb, flags, &rc, TRUE);
+
+    ExReleaseResourceLite(&Vcb->chunk_lock);
+
+    if (NT_SUCCESS(Status)) {
+        *newchunk = rc;
+        return Status;
+    } else {
+        ERR("alloc_chunk returned %08x\n", Status);
+        return Status;
+    }
+}
+
+static NTSTATUS regenerate_space_list(device_extension* Vcb, device* dev) {
+    LIST_ENTRY* le;
+
+    while (!IsListEmpty(&dev->space)) {
+        space* s = CONTAINING_RECORD(RemoveHeadList(&dev->space), space, list_entry);
+
+        ExFreePool(s);
+    }
+
+    // The Linux driver doesn't like to allocate chunks within the first megabyte of a device.
+
+    space_list_add2(&dev->space, NULL, 0x100000, dev->devitem.num_bytes - 0x100000, NULL, NULL);
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        UINT16 n;
+        chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+
+        for (n = 0; n < c->chunk_item->num_stripes; n++) {
+            UINT64 stripe_size = 0;
+
+            if (cis[n].dev_id == dev->devitem.dev_id) {
+                if (stripe_size == 0) {
+                    UINT16 factor;
+
+                    if (c->chunk_item->type & BLOCK_FLAG_RAID0)
+                        factor = c->chunk_item->num_stripes;
+                    else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
+                        factor = c->chunk_item->num_stripes / c->chunk_item->sub_stripes;
+                    else if (c->chunk_item->type & BLOCK_FLAG_RAID5)
+                        factor = c->chunk_item->num_stripes - 1;
+                    else if (c->chunk_item->type & BLOCK_FLAG_RAID6)
+                        factor = c->chunk_item->num_stripes - 2;
+                    else // SINGLE, DUP, RAID1
+                        factor = 1;
+
+                    stripe_size = c->chunk_item->size / factor;
+                }
+
+                space_list_subtract2(&dev->space, NULL, cis[n].offset, stripe_size, NULL, NULL);
+            }
+        }
+
+        le = le->Flink;
+    }
+
+    return STATUS_SUCCESS;
+}
+
+_Function_class_(KSTART_ROUTINE)
 #ifndef __REACTOS__
-static void balance_thread(void* context) {
+void balance_thread(void* context) {
 #else
-static void NTAPI balance_thread(void* context) {
+void NTAPI balance_thread(void* context) {
 #endif
     device_extension* Vcb = (device_extension*)context;
     LIST_ENTRY chunks;
     LIST_ENTRY* le;
-    UINT64 num_chunks[3];
+    UINT64 num_chunks[3], okay_metadata_chunks = 0, okay_data_chunks = 0, okay_system_chunks = 0;
+    UINT64 old_data_flags = 0, old_metadata_flags = 0, old_system_flags = 0;
     NTSTATUS Status;
-    
+
+    Vcb->balance.balance_num++;
+
     Vcb->balance.stopping = FALSE;
-    Vcb->balance.cancelling = FALSE;
     KeInitializeEvent(&Vcb->balance.finished, NotificationEvent, FALSE);
-    
-    if (Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_CONVERT)
+
+    if (Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_CONVERT) {
+        old_data_flags = Vcb->data_flags;
         Vcb->data_flags = BLOCK_FLAG_DATA | (Vcb->balance.opts[BALANCE_OPTS_DATA].convert == BLOCK_FLAG_SINGLE ? 0 : Vcb->balance.opts[BALANCE_OPTS_DATA].convert);
-    
-    if (Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_CONVERT)
+
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+    }
+
+    if (Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_CONVERT) {
+        old_metadata_flags = Vcb->metadata_flags;
         Vcb->metadata_flags = BLOCK_FLAG_METADATA | (Vcb->balance.opts[BALANCE_OPTS_METADATA].convert == BLOCK_FLAG_SINGLE ? 0 : Vcb->balance.opts[BALANCE_OPTS_METADATA].convert);
-    
-    if (Vcb->balance.opts[BALANCE_OPTS_SYSTEM].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_SYSTEM].flags & BTRFS_BALANCE_OPTS_CONVERT)
+    }
+
+    if (Vcb->balance.opts[BALANCE_OPTS_SYSTEM].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_SYSTEM].flags & BTRFS_BALANCE_OPTS_CONVERT) {
+        old_system_flags = Vcb->system_flags;
         Vcb->system_flags = BLOCK_FLAG_SYSTEM | (Vcb->balance.opts[BALANCE_OPTS_SYSTEM].convert == BLOCK_FLAG_SINGLE ? 0 : Vcb->balance.opts[BALANCE_OPTS_SYSTEM].convert);
-    
+    }
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_MIXED_GROUPS) {
         if (Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED)
             RtlCopyMemory(&Vcb->balance.opts[BALANCE_OPTS_METADATA], &Vcb->balance.opts[BALANCE_OPTS_DATA], sizeof(btrfs_balance_opts));
@@ -2572,48 +3067,51 @@
         else if (Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED)
             RtlCopyMemory(&Vcb->balance.opts[BALANCE_OPTS_DATA], &Vcb->balance.opts[BALANCE_OPTS_METADATA], sizeof(btrfs_balance_opts));
     }
-    
+
+    num_chunks[0] = num_chunks[1] = num_chunks[2] = 0;
+    Vcb->balance.total_chunks = Vcb->balance.chunks_left = 0;
+
+    InitializeListHead(&chunks);
+
     // FIXME - what are we supposed to do with limit_start?
-    
+
     if (!Vcb->readonly) {
-        if (!Vcb->balance.removing) {
+        if (!Vcb->balance.removing && !Vcb->balance.shrinking) {
             Status = add_balance_item(Vcb);
             if (!NT_SUCCESS(Status)) {
                 ERR("add_balance_item returned %08x\n", Status);
+                Vcb->balance.status = Status;
                 goto end;
             }
         } else {
             if (Vcb->need_write) {
-                LIST_ENTRY rollback;
-                
-                InitializeListHead(&rollback);
-                do_write(Vcb, NULL, &rollback);
+                Status = do_write(Vcb, NULL);
+
                 free_trees(Vcb);
-                
-                clear_rollback(Vcb, &rollback);
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("do_write returned %08x\n", Status);
+                    Vcb->balance.status = Status;
+                    goto end;
+                }
             }
         }
     }
-    
-    num_chunks[0] = num_chunks[1] = num_chunks[2] = 0;
-    Vcb->balance.total_chunks = 0;
-    
-    InitializeListHead(&chunks);
-    
+
     KeWaitForSingleObject(&Vcb->balance.event, Executive, KernelMode, FALSE, NULL);
-    
+
     if (Vcb->balance.stopping)
         goto end;
-    
+
     ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
-    
+
     le = Vcb->chunks.Flink;
     while (le != &Vcb->chunks) {
         chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
         UINT8 sort;
-        
+
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
+
         if (c->chunk_item->type & BLOCK_FLAG_DATA)
             sort = BALANCE_OPTS_DATA;
         else if (c->chunk_item->type & BLOCK_FLAG_METADATA)
